/***************************************************************************
 *                                                                         *
 *                              QNotify                                    *
 *                                                                         *
 *            Copyright (C) 2006 Holger Macht <holger@homac.de>            *
 *                                                                         *
 *                 Author: Holger Macht <holger@homac.de>                  *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify it *
 * under the terms of the GNU General Public License as published by the   *
 * Free Software Foundation; either version 2 of the License, or (at you   *
 * option) any later version.                                              *
 *                                                                         *
 * This program is distributed in the hope that it will be useful, but     *
 * WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
 * General Public License for more details.                                *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc., *
 * 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA                  *
 *                                                                         *
 ***************************************************************************/

#include "align.h"
#include <iostream>
#include <qapplication.h>

align::align()
{
}

align::~align()
{
}

//align from the top left to the bottom right corner horizontally 
QNotifyPopup *align::ltop_rbottom_h(QNotifyPopup* lab, wNode * firstLab, wNode * lastLab)
{
	int desktopGeo[2];
	desktopGeo[0] = qApp->desktop()->width();
	desktopGeo[1] = qApp->desktop()->height();

//    std::cerr << "firstLab x: " << firstLab->x << "\n";
//    std::cerr << "lastLab x: " << lastLab->x << "\n";
	int first = firstLab->x;
	int highest = firstLab->height;
	int space = 10;
	//if the current lab is the second one displayed in a row,

	int xpos, ypos;
	xpos = lastLab->x + lastLab->width + space;
	ypos = lastLab->y;
	lab->move(xpos, ypos);
//    std::cerr << "xpos: " << xpos << "\n";
//    std::cerr << "ypos: " << ypos << "\n";

	// if the new widget is wider than the desktop start a new row
	if (lab->x() + lab->width() >= desktopGeo[0]) {
		ypos = highest + lastLab->y + space;
		xpos = first;
		lab->move(xpos, ypos);
		highest = lab->height();
	}

	if (lab->height() > highest)
		highest = lab->height();

	return lab;
}

QNotifyPopup *align::ltop_rbottom_v(QNotifyPopup * lab, wNode * firstLab, wNode * lastLab)
{
	int desktopGeo[2];
	desktopGeo[0] = qApp->desktop()->width();
	desktopGeo[1] = qApp->desktop()->height();

	int first = firstLab->y;
	int widest = firstLab->width;
	int space = 10;

	int xpos, ypos;
	xpos = lastLab->x;
	ypos = lastLab->y + lastLab->height + space;
	lab->move(xpos, ypos);
	// if the new widget is wider than the desktop start a new row
	if (lab->y() + lab->height() >= desktopGeo[1]) {
		ypos = first;
		xpos = widest + lastLab->x + space;
		lab->move(xpos, ypos);
		widest = lab->width();
	}

	if (lab->width() > widest)
		widest = lab->width();

	return lab;
}

QNotifyPopup *align::ltop_rbottom_d(QNotifyPopup * lab, wNode * firstLab, wNode * lastLab)
{
	int desktopGeo[2];
	desktopGeo[0] = qApp->desktop()->width();
	desktopGeo[1] = qApp->desktop()->height();

	int xfirst = firstLab->x;
	int yfirst = firstLab->y;
	int widthFirst = firstLab->width;
	int space = 10;

	int xpos, ypos;
	ypos = lastLab->y + lastLab->height;
	xpos = lastLab->x + lastLab->width;
	lab->move(xpos, ypos);

	// if the new widget is wider than the desktop start a new row
	if (lab->x() + lab->width() >= desktopGeo[0] || lab->y() + lab->height() >= desktopGeo[1]) {
		ypos = yfirst - space;
		xpos = xfirst + widthFirst + space;
		yfirst -= space;
		lab->move(xpos, ypos);
		xfirst = lab->x();
		widthFirst = lab->width();
	}

	return lab;
}
