/***************************************************************************
 *                                                                         *
 *                              QNotify                                    *
 *                                                                         *
 *            Copyright (C) 2008 Holger Macht <holger@homac.de>            *
 *                                                                         *
 *                 Author: Holger Macht <holger@homac.de>                  *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify it *
 * under the terms of the GNU General Public License as published by the   *
 * Free Software Foundation; either version 2 of the License, or (at you   *
 * option) any later version.                                              *
 *                                                                         *
 * This program is distributed in the hope that it will be useful, but     *
 * WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
 * General Public License for more details.                                *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc., *
 * 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA                  *
 *                                                                         *
 ***************************************************************************/

#ifndef FILEIO_H
#define FILEIO_H

#include "widgetNode.h"

#include <qstringlist.h>
#include <qfile.h>

class FileIO {
public:
	FileIO();
	
	bool init(QString filename);
	int getFirst(wNode * node);
	int getLast(wNode * node);
	int writeFile(wNode * node);
	int close();

private:
	QValueList<wNode> _list;

	int getInactiveWidgets();

	void setInactiveWidgets(int count);
	void checkTimeouts();

	bool createFile(QString filename, int flags);

	int _inactiveWidgets;
	QFile _file;

	int parseLine(wNode * node, QString buf);
};

#endif
