/***************************************************************************
 *                                                                         *
 *                              QNotify                                    *
 *                                                                         *
 *            Copyright (C) 2006 Holger Macht <holger@homac.de>            *
 *                                                                         *
 *                 Author: Holger Macht <holger@homac.de>                  *
 *                                                                         *
 * This program is free software; you can redistribute it and/or modify it *
 * under the terms of the GNU General Public License as published by the   *
 * Free Software Foundation; either version 2 of the License, or (at you   *
 * option) any later version.                                              *
 *                                                                         *
 * This program is distributed in the hope that it will be useful, but     *
 * WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
 * General Public License for more details.                                *
 *                                                                         *
 * You should have received a copy of the GNU General Public License along *
 * with this program; if not, write to the Free Software Foundation, Inc., *
 * 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA                  *
 *                                                                         *
 ***************************************************************************/

#ifndef SETTINGS_H
#define SETTINGS_H

#include "contrib/getopt.h"

typedef struct globopts {
	QStringList text;
	//holds the optionstring for each text
	 QValueList < QStringList > opts;
	QString filename;
	bool help;
	bool image;
	bool pdialog;
	bool msgbox;
	QString socketfile;
	QString alignfunc;
	QString fifofile;
	bool norounding;
	int width;
	int height;
	int xPos;
	int yPos;
	int fontsize;
	int count;
	float showtime;
	float hidetime;
	QString foregroundColor;
	QString backgroundColor;
	QString pbarColor;
	int pbarHeight;
	bool fullscreen;
	bool alert;
	char textalignment;
	int step;
	int fulltime;
	bool plain;
	bool noshadow;
	bool frame;
	QString alignmentStr;
	int spacing;
	bool center;
	int rounding_factor;
	bool transparent;
	QString coordFile;
	bool auto_widget;
	bool no_alignment;

} global_options;

class Settings:public GetOpt {
      public:
	Settings(const QStringList & a);
	 Settings(int argc, char *argv[]);
	~Settings();

	void parse_cmdline(int *argc, char ***argv);
	void setDefaults();
	void clear();

      private:

	void setParams();

	QString width, height, xPos, yPos, fontsize, count;
	QString showtime, hidetime, step, fulltime, spacing, pbarHeight;
	QString rounding, text;

	QString interval;

};

#endif
